/// @cond EO_CXX_EO_IMPL

inline ::elm::glview::_c_version_constructor elm::glview::version_constructor(Evas_GL_Context_Version version_)
{
   return _c_version_constructor(version_);
}

inline void elm::glview::size_get(int* w_, int* h_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_glview_size_get(w_, h_));
}

inline void elm::glview::size_set(int w_, int h_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_glview_size_set(w_, h_));
}

inline bool elm::glview::resize_policy_set(Elm_GLView_Resize_Policy policy_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_glview_resize_policy_set(policy_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::glview::changed_set() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_glview_changed_set());
}

inline void elm::glview::resize_func_set(Elm_GLView_Func_Cb func_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_glview_resize_func_set(func_));
}

inline void elm::glview::del_func_set(Elm_GLView_Func_Cb func_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_glview_del_func_set(func_));
}

inline void elm::glview::init_func_set(Elm_GLView_Func_Cb func_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_glview_init_func_set(func_));
}

inline bool elm::glview::render_policy_set(Elm_GLView_Render_Policy policy_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_glview_render_policy_set(policy_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool elm::glview::mode_set(Elm_GLView_Mode mode_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_glview_mode_set(mode_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::glview::render_func_set(Elm_GLView_Func_Cb func_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_glview_render_func_set(func_));
}

inline Evas_GL_API * elm::glview::gl_api_get() const
{
   Evas_GL_API * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_glview_gl_api_get());
   return _tmp_ret;
}

inline Evas_GL * elm::glview::evas_gl_get() const
{
   Evas_GL * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_glview_evas_gl_get());
   return _tmp_ret;
}

inline int elm::glview::rotation_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_glview_rotation_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::glview::size_get(int* w_, int* h_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_glview_size_get(w_, h_));
}

inline void eo_cxx::elm::glview::size_set(int w_, int h_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_glview_size_set(w_, h_));
}

inline bool eo_cxx::elm::glview::resize_policy_set(Elm_GLView_Resize_Policy policy_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_glview_resize_policy_set(policy_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::glview::changed_set() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_glview_changed_set());
}

inline void eo_cxx::elm::glview::resize_func_set(Elm_GLView_Func_Cb func_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_glview_resize_func_set(func_));
}

inline void eo_cxx::elm::glview::del_func_set(Elm_GLView_Func_Cb func_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_glview_del_func_set(func_));
}

inline void eo_cxx::elm::glview::init_func_set(Elm_GLView_Func_Cb func_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_glview_init_func_set(func_));
}

inline bool eo_cxx::elm::glview::render_policy_set(Elm_GLView_Render_Policy policy_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_glview_render_policy_set(policy_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool eo_cxx::elm::glview::mode_set(Elm_GLView_Mode mode_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_glview_mode_set(mode_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::glview::render_func_set(Elm_GLView_Func_Cb func_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_glview_render_func_set(func_));
}

inline Evas_GL_API * eo_cxx::elm::glview::gl_api_get() const
{
   Evas_GL_API * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_glview_gl_api_get());
   return _tmp_ret;
}

inline Evas_GL * eo_cxx::elm::glview::evas_gl_get() const
{
   Evas_GL * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_glview_evas_gl_get());
   return _tmp_ret;
}

inline int eo_cxx::elm::glview::rotation_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_glview_rotation_get());
   return _tmp_ret;
}

inline ::eo_cxx::elm::glview::operator ::elm::glview() const
{
   return *static_cast<::elm::glview const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::glview::operator ::elm::glview&()
{
   return *static_cast<::elm::glview*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::glview::operator ::elm::glview const&() const
{
   return *static_cast<::elm::glview const*>(static_cast<void const*>(this));
}

template <typename T>
void elm_glview_size_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int* w_, int* h_)
{
   try
      {
         static_cast<T*>(self->this_)->size_get(w_, h_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_glview_size_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int w_, int h_)
{
   try
      {
         static_cast<T*>(self->this_)->size_set(w_, h_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_glview_resize_policy_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_GLView_Resize_Policy policy_)
{
   try
      {
         return static_cast<T*>(self->this_)->resize_policy_set(policy_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_glview_changed_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->changed_set();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_glview_resize_func_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_GLView_Func_Cb func_)
{
   try
      {
         static_cast<T*>(self->this_)->resize_func_set(func_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_glview_del_func_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_GLView_Func_Cb func_)
{
   try
      {
         static_cast<T*>(self->this_)->del_func_set(func_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_glview_init_func_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_GLView_Func_Cb func_)
{
   try
      {
         static_cast<T*>(self->this_)->init_func_set(func_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_glview_render_policy_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_GLView_Render_Policy policy_)
{
   try
      {
         return static_cast<T*>(self->this_)->render_policy_set(policy_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
bool elm_glview_mode_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_GLView_Mode mode_)
{
   try
      {
         return static_cast<T*>(self->this_)->mode_set(mode_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_glview_render_func_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_GLView_Func_Cb func_)
{
   try
      {
         static_cast<T*>(self->this_)->render_func_set(func_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Evas_GL_API * elm_glview_gl_api_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->gl_api_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Evas_GL_API * _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
Evas_GL * elm_glview_evas_gl_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->evas_gl_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Evas_GL * _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
int elm_glview_rotation_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->rotation_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         int _tmp_ret{};
         return _tmp_ret;
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::glview >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::widget >::template type<T>
   {
      virtual void size_get(int* w_, int* h_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_glview_size_get(w_, h_));
      }

      virtual void size_set(int w_, int h_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_glview_size_set(w_, h_));
      }

      virtual bool resize_policy_set(Elm_GLView_Resize_Policy policy_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_glview_resize_policy_set(policy_));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void changed_set()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_glview_changed_set());
      }

      virtual void resize_func_set(Elm_GLView_Func_Cb func_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_glview_resize_func_set(func_));
      }

      virtual void del_func_set(Elm_GLView_Func_Cb func_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_glview_del_func_set(func_));
      }

      virtual void init_func_set(Elm_GLView_Func_Cb func_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_glview_init_func_set(func_));
      }

      virtual bool render_policy_set(Elm_GLView_Render_Policy policy_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_glview_render_policy_set(policy_));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool mode_set(Elm_GLView_Mode mode_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_glview_mode_set(mode_));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void render_func_set(Elm_GLView_Func_Cb func_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_glview_render_func_set(func_));
      }

      virtual Evas_GL_API * gl_api_get()
      {
         Evas_GL_API * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_glview_gl_api_get());
            return _tmp_ret;
      }

      virtual Evas_GL * evas_gl_get()
      {
         Evas_GL * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_glview_evas_gl_get());
            return _tmp_ret;
      }

      virtual int rotation_get()
      {
         int _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_glview_rotation_get());
            return _tmp_ret;
      }

   };
};


template<>
struct operation_description_class_size< ::elm::glview >
{
   static constexpr int value = 
#if defined(GLVIEW_PROTECTED) && defined(GLVIEW_BETA)
      13
#elif defined(GLVIEW_PROTECTED)
      13
#elif defined(GLVIEW_BETA)
      13
#else
      13
#endif
      + operation_description_class_size<::elm::widget >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::glview>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_glview_size_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_glview_size_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_glview_size_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_glview_size_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_glview_resize_policy_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_glview_resize_policy_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_glview_changed_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_glview_changed_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_glview_resize_func_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_glview_resize_func_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_glview_del_func_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_glview_del_func_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_glview_init_func_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_glview_init_func_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_glview_render_policy_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_glview_render_policy_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_glview_mode_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_glview_mode_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_glview_render_func_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_glview_render_func_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_glview_gl_api_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_glview_gl_api_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_glview_evas_gl_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_glview_evas_gl_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_glview_rotation_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_glview_rotation_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::widget>(), &ops[operation_description_class_size< ::elm::glview >::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::glview>)
{
   return (ELM_GLVIEW_CLASS);
}

} } }

/// @endcond

